/*
** $Log:   C:/shell/vcs/cp.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:29:24   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:23:04   kent
**Initial revision.
*/
static char target_name[128];
#ifdef MAIN
#include <stdio.h>
int no_map_backslashes = 1;
char *me;
int main
#else
#include "shell.h"
int
cp
#endif
(argc,argv)
int argc;
register char *argv[];
{
    static char *usage = "cp : usage cp file1 [file2 . . fileN] target\r\n";
    char target[128],*fname_part(); char verbose = 0;
	extern char *abspath(),*strchr();
	char *tpath,*spath;
	register int i;
#ifdef MAIN
	me = "cp";
#else
    me = argv[0];
#endif
	if (argc > 1 && strcmp(argv[1],"-v")==0 || strcmp(argv[1],"-V")==0)
	{
		++argv; --argc; ++verbose;
	}
    if (argc < 3)
    {
		write(2,usage,strlen(usage));
		return(-1);
    }
	if (NULL == (tpath = abspath(argv[argc-1])))
	{
		fprintf(stderr,"cp : ill formed filename %s\n",argv[argc-1]);
		return -1;
	}
    strcpy(target,tpath);
#ifdef DEBUG
	fprintf(stderr,"target = %s\n",target);
#endif
    if (strchr("\\/",target[i = strlen(target) - 1]) != NULL)
		target[i] = '\0';
    if (argc == 3)
    {
		if (!dirp(target))
		{
#ifdef DEBUG
			fprintf(stderr,"target exists, not a directory\n");
#endif
			if (NULL == (spath = abspath(argv[1])))
			{
				fprintf(stderr,"cp : ill formed filename %s\n",argv[1]);
				return -1;
			}
#ifdef DEBUG
		fprintf(stderr,"target_name = %s,spath = %s, argv[i] = %s\n",
			target,spath,argv[1]);
#endif
			if (verbose)
				fprintf(stderr,"copying %s to %s\n",spath,target);
		    if(-1 == filecopy(target,spath))
		    {
				perror(me);
				return -1;
		    }
		}
		else
		{
#ifdef DEBUG
			fprintf(stderr,"target a directory\n");
#endif
			strcpy(target_name,target);
			strcat(target_name,"/");
			if (NULL == (spath = abspath(argv[1])))
			{
				fprintf(stderr,"cp : ill formed filename %s\n",argv[1]);
				return -1;
			}
			strcat(target_name,fname_part(spath));
#ifdef DEBUG
			fprintf(stderr,"target_name = %s,spath = %s, argv[i] = %s\n",
			target_name,spath,argv[1]);
#endif
			if (verbose)
				fprintf(stderr,"copying %s to %s\n",spath,target_name);
			if (-1 == filecopy(target_name,spath))
			{
			    perror(me);
			    return -1;
			}
	    }
		return(0);
    }
    for (i = 1; i < argc-1; i++)
    {
		strcpy(target_name,target);
		strcat(target_name,"/");
		if (NULL == (spath = abspath(argv[i])))
		{
			fprintf(stderr,"cp : ill formed filename %s\n",argv[1]);
			return -1;
		}
		strcat(target_name,fname_part(spath));
#ifdef DEBUG
		fprintf(stderr,"target_name = %s,spath = %s, argv[i] = %s\n",
			target_name,spath,argv[i]);
#endif
		if (!filep(spath))
		{
		    fprintf(stderr,"cp : %s isn't a file\n",argv[i]);
		    continue;
		}
		if (verbose)
			fprintf(stderr,"copying %s to %s\n",argv[i],target_name);
		if (-1 == filecopy(target_name,spath))
		{
		    perror(me);
		    return -1;
		}
    }
    return 0;
}
