/*
** $Log:   C:/shell/vcs/mv.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:29:58   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:23:34   kent
**Initial revision.
*/
#ifndef MAIN
#include "shell.h"
#else
#include <stdio.h>
char *savestr();
int no_map_backslashes = 0;
char *me = "mv";
#endif
/* mv.c - implements a version of UNIX mv */

int
#ifdef MAIN
main
#else
mv
#endif
(argc,argv)
	int argc;
	register char *argv[];
{
	static char *usage = "mv : usage mv [-v] file1 [file2 . . fileN] target\r\n";
	static char target_name[128];
	static char target[128];
	extern char *fname_part(),*strchr(),*abspath();
	char *spath,*tpath;
	int verbose=0; 
	register int i;
#ifndef MAIN
	me = argv[0];	/* referenced in routines common with cp.c */
#endif
	if (argc < 3)
	{
		write(2,usage,strlen(usage));
		return(-1);
	}
	if (NULL == (tpath = abspath(argv[argc-1])))
	{
		fprintf(stderr,"%s : ill formed target name %s\n",argv[argc-1]);
		return(-1);
	}
	strcpy(target,tpath);	/* copy absolue target path */
	if (strcmp(argv[1],"-v")==0||strcmp(argv[1],"-V")==0)
	{
		++argv; --argc;
		verbose++;
	}
	/* kill trailing backslashes */
	if (NULL != strchr("\\/",target[strlen(target) - 1]))
		target[strlen(target)-1] = '\0';
	if (argc == 3)
	{
		if (!dirp(target))	/* it isn't a directory */
		{
			if (NULL == (spath = abspath(argv[1])))
				goto badname;	/* bad file name */
			if (verbose)
				fprintf(stderr,"moving %s to %s\n"
					,argv[1],target);
			if (dirp(spath))
			{
				if (0 != rename(spath,target))
				{
					perror("mv");
					return -1;
				}
				return 0;
			} else if (-1 == maybecopy(target,spath))
			{
				perror("mv");
				return -1;
			}
			else
				unlink(spath);
		}
		else
		{
			/* target is a directory, copy to same name that dir */
			strcpy(target_name,target);
			if (NULL==strchr("/\\",target_name[strlen(target_name)-1]))
					strcat(target_name,"/");
			strcat(target_name,fname_part(argv[1]));
			if (NULL == (spath = abspath(argv[1])))
			{
badname:
				fprintf(stderr,"mv : ill formed file name %s\n",argv[1]);
				return -1;
			}
			if (verbose)
				fprintf(stderr,
					"moving %s to %s\n"
						,spath,target_name);
			if (-1 != maybecopy(target_name,spath))
				unlink(spath);
			else
			{
				perror("mv");
				return -1;
			}
		}
		return(0);
	}
	if (!dirp(target))
	{
		fprintf(stderr,"mv : %s isn't a directory\n",target);
		return(-1);
	}
	for (i = 1; i < argc-1; i++)
	{
		if (0 == strcmp(".",fname_part(argv[i])) ||
   		    0 == strcmp("..",fname_part(argv[i])))
			continue;
		strcpy(target_name,target);
		if (NULL==strchr("\\/",target_name[strlen(target_name)-1]))
			strcat(target_name,"/");
		strcat(target_name,fname_part(argv[i]));
		if (NULL == (spath = abspath(argv[i])))
		{
			fprintf("mv : badly formed file name %s\n",argv[i]);
			return -1;
		}
		if (verbose)
			fprintf(stderr,"moving %s to %s\n",spath,target_name);
		if (!filep(spath))
		{
			fprintf(stderr,"mv : %s isn't a file\n",spath);
			continue;
		}
		if (-1 != maybecopy(target_name,spath))
			unlink(spath);
		else
		{
			perror("mv");
			return -1;
		}
	}
	return 0;
}

int maybecopy(target,source)
	char *target,*source;
{
	char *drive_part();
	static char targetdrive[3], sourcedrive[3];
	strcpy(targetdrive,drive_part(target));
	strcpy(sourcedrive,drive_part(source));
	if (0 == strcmp(targetdrive,sourcedrive))
	{
		if (filep(source))
		{
			unlink(target);
			if (-1 != rename(source,target))
				return 0;
		}
		else
		{
			fprintf(stderr,"%s not found\n",source);
			return -1;
		}
	}
	return (filecopy(target,source));
}
