/*
** $Log:   C:/SHELL/VCS/SHELL.H_V  $
   
      Rev 3.5   02 Oct 1986 12:47:26   kent
   lint pass over everything
   
      Rev 3.4   01 Oct 1986 13:18:00   kent
   Initial revision.
** shell.h - container of all global definitions
*/

/* define what compiler we're using */
/* #define AZTEC86 */
/* #define MSC */
#define LINT_ARGS
#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
#include <fcntl.h>
#include <ctype.h>
#ifdef MSC
#include <string.h>
#include <stdlib.h>
#include <direct.h>
#include <dos.h>
#endif

#ifdef AZTEC86
#define O_TEXT 0
#endif

#define BADQUOTES ((void *)-1)
#define UZERO ((unsigned)0)
#define TRUE 1
#define FALSE 0

/* define macros so that storage only gets declared once */
#ifdef MAIN
#define EXTERN
#define INITIAL(X) =X
#else
#define EXTERN extern
#define INITIAL(X)
#endif

/* structure of the command table */
typedef struct
{
	char *cmdname;
	int (*func)();
} builtin;

/* structure of the shell history instance variables */
typedef struct
{
	unsigned j,hiscount,histsize;
	char **history;
} hist_env;

/* at any given time, the current set of shell history instance variables */
EXTERN hist_env *_current;

/*lint -e532 all of the internal commands */
extern int 
#ifndef SMALL
/* large dispensible commands */
ls(), 
cp(), 
mv(),
more(),
fgrep(),
dump(),
#endif
cmds(), rm(), 
pushd(),popd(),drive(), ver(),du(),dirs(),
scr_clear(),set(),ch_mod(),cat(),echo(),  y(),t(), switchar(),
cli(),alias(),unalias(), last(),invalid(),sh(),shell_read(),
md(),touch(),cd(),pwd(),rd(),hist(),my_exit();
#ifdef AZTEC86
extern int mon();
#endif
/*lint +e532 -e15 */

#ifdef MAIN
/* the command array */
builtin commands[] =
{
	"a:",drive,
	"alias",alias,
	"b:",drive,
	"c:",drive,
	"cat",cat,
	"cd",cd,
	"chdir",cd,
	"chmod",ch_mod,
	"cls",scr_clear,
	"commands",cmds,
#ifndef SMALL
	"cp",cp,
#endif
	"d:",drive,
	"del",rm,
#ifndef SMALL
	"dirs",dirs,
	"du",du,
	"dump",dump,
#endif
	"e:",drive,
	"echo",echo,
	"era",rm,
	"erase",rm,
	"error",last,
	"exit",my_exit,
	"f:",drive,
#ifndef SMALL
	"fgrep",fgrep,
#endif
	"g:",drive,
	"h:",drive,
#ifndef SMALL
	"hd",dump,
#endif
	"history",hist,
	"i:",drive,
	"j:",drive,
	"k:",drive,
	"l:",drive,
#ifndef SMALL
	"ls",ls,
#endif
	"m:",drive,
	"md",md,
	"mkdir",md,
#ifndef SMALL
#ifdef AZTEC86
	"mon",mon,
#endif
	"more",more,
	"mv",mv,
#endif
	"n:",drive,
	"o:",drive,
	"p:",drive,
	"popd",popd,
	"pushd",pushd,
	"pwd",pwd,
	"q:",drive,
	"r:",drive,
	"rd",rd,
	"read",shell_read,
	"rm",rm,
	"rmdir",rd,
	"s:",drive,
	"set",set,
	"sh",sh,
	"switchar",switchar,
	"t:",drive,
	"tee",t,
	"touch",touch,
	"u:",drive,
	"unalias",unalias,
	"v:",drive,
	"version",ver,
	"w:",drive,
	"x:",drive,
	"y",y,
	"y:",drive,
	"z:",drive
};
unsigned int numcmds =  (sizeof(commands)/sizeof(builtin));
char *version = "$Revision:   3.5  $\n$Date:   02 Oct 1986 12:47:26  $\n";
#ifdef SMALL
/*
** some stuff that otherwise is missing in the small shell, because of
** its residence in omitted commands
*/
#ifndef NULL
#define NULL ((void *)0)
#endif

char *me = "";

typedef struct
{
	char attribute;
	unsigned file_time;
	unsigned file_date;
	long file_size;
	char file_name[13];
} file_desc;

typedef struct
{
	char dos_reserved[21];
	file_desc file;
} fcb;
fcb tmp;

int filep(s)
char *s;
{
    /* set the disk transfer address */
    bdos(0x1A,&tmp);
    /* do a search first for the directory path */
    return bdos(0x4E,s,0) == 0;
}

file_desc *getfirst(fname)
	char *fname;
{
	register int result;
	/* set the disk transfer address */
	bdos(0x1A,&tmp);
	result = bdos(0x4E,fname,0);
	/* make the find first call */
	if(2 == result || 18 == result)
		return NULL;
	return &(tmp.file);
}

file_desc *getnext()
{
	register int result;
	/* set the disk transfer address */
	bdos(0x1A,&tmp);
	result = bdos(0x4f,0,0);
	/* make the find next call */
	if (18 == result)
		return NULL;
	return &(tmp.file);
}

char *get_first_name(name)
	char *name;
{
	file_desc *x;
	if (NULL == (x = getfirst(name)))
		return NULL;
	return x->file_name;
}

char *get_next_name()
{
	file_desc *x;
	if (NULL == (x = getnext()))
		return NULL;
	return x->file_name;
}
char *path_part(s)
register char *s;
{
	static char buffer[64];
    register char *r; 
    char *strrchr();
	strcpy(buffer,s);	/* copy string */
	if ((r = strrchr(buffer,'/')) ||
		(r = strrchr(buffer,'\\')))
	{
		*++r = '\0';
		for (r = buffer; '\0' != *r; r++)
			*r = (*r == '\\' ? '/' : *r);
		return buffer;
	}

	if (r = strrchr(buffer,':'))
	{
		*++r = '\0';
		return buffer;
	}
	return NULL;
}
#endif
#else
extern builtin commands[];
extern unsigned int numcmds;
extern char *version;
#endif

/* GLOBAL VARIABLES */
EXTERN int no_map_backslashes INITIAL(0);
EXTERN int quiet;
EXTERN int histecho;
EXTERN char *histerr INITIAL("no history");
EXTERN int verbose INITIAL(0);

#ifdef MAIN
char pdirty[2] = { 0,0 };
#else
extern char pdirty[2];
#endif

EXTERN char *pipename [2];
EXTERN char *herename;
EXTERN int  currname INITIAL(0);
EXTERN int result INITIAL(0);
EXTERN char oldswitch;
EXTERN int env_paragraph;
EXTERN char *me;

/*
** various public functions
*/
extern int std_save();
extern void std_restore(),safestrcat();
extern void do_prompt();
extern char *ntharg();
extern int lastarg();
extern char *get_env();
extern void env_change_backslashes();
extern char *fname_part(),*savestr();
extern char *expand();
extern char *path_part();
extern char *get_first_name(), *get_next_name();
extern char *addtoline();
extern char *str_lower();

/*
** library externals
*/
#ifndef MSC
extern void (*signal())();
extern char *strchr(), *strrchr();
extern char *getcwd();
extern int printf(), fprintf();
#endif

/*
** memory allocation debug stuff
*/
#ifdef MEMDEBUG
#define Malloc(x)	dmalloc(__FUNC__,__LINE__,x)
#define Free(x)		dfree(__FUNC__,__LINE__,x)
#define MustMalloc(x) Must_Malloc(__FUNC__,__LINE__,x)
#define MustRealloc(ptr,x) Must_Realloc(__FUNC__,__LINE__,ptr,x)

#ifdef AZTEC86
void *realloc();
void *malloc();
int free();
#endif

#ifdef MSC
#include <malloc.h>
#endif

void *dmalloc();
void dfree();

#else

#define Malloc(x)	malloc(x)
#define Free(x)		free(x)
#define MustMalloc(x) Must_Malloc(x)
#define MustRealloc(a,x) Must_Realloc(a,x)
#define CMDBUFSIZ (unsigned)128

#ifndef MSC
void *malloc(),*realloc();
#else
#include <malloc.h>
#endif

void *Must_Malloc();		/* quit if no memory is available */
void *Must_Realloc();

#endif
#define CMDBUFSIZ (unsigned)128

#ifdef AZTEC86
struct registers { int ax,bx,cx,dx,si,di,ds,es; };
#define sysint21(x,y)	sysint(0x21,x,y)
#define FTOREAD "r"
#endif
#ifdef MSC
struct registers { unsigned int ax,bx,cx,dx,si,di,cflag, es, cs, ss, ds; };
#define sysint21(x,y)	intdosx((union REGS *)(x),\
			(union REGS *)(y),(struct SREGS *)&((x)->es));
#define GETSEGS(x)	segread((struct SREGS *)&((x)->es))
#define FTOREAD "rt"
#endif

#ifndef min
#define min(a,b) a < b ? a : b
#endif
#ifndef max
#define max(a,b) a > b ? a : b
#endif
